/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : Cpu.C
**     Project   : RTOSdemo
**     Processor : MC9S12XEP100MAG
**     Beantype  : MC9S12XEP100_144
**     Version   : Bean 01.002, Driver 02.01, CPU db: 3.00.002
**     Datasheet : MC9S12XEP100 Rev. 1.13 11/2007
**     Compiler  : CodeWarrior HCS12X C Compiler
**     Date/Time : 10.04.08, 10:13
**     Abstract  :
**         This bean "MC9S12XEP100_144" implements properties, methods,
**         and events of the CPU.
**     Settings  :
**
**     Contents  :
**         EnableInt   - void Cpu_EnableInt(void);
**         DisableInt  - void Cpu_DisableInt(void);
**         SetWaitMode - void Cpu_SetWaitMode(void);
**         SetStopMode - void Cpu_SetStopMode(void);
**         Delay100US  - void Cpu_Delay100US(word us100);
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2007
**     UNIS, spol. s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

/* MODULE Cpu. */

#include "TickTimer.h"
#include "COM0.h"
#include "IV1.h"
#include "Byte1.h"
#include "Events.h"
#include "Cpu.h"

#define CGM_DELAY  0x17FFUL

#pragma DATA_SEG DEFAULT
#pragma CODE_SEG DEFAULT


/* Global variables */
volatile byte CCR_reg;                 /* Current CCR reegister */

/*Definition of global shadow variables*/
byte Shadow_A;

#pragma CODE_SEG __NEAR_SEG NON_BANKED


/*
** ===================================================================
**     Method      :  Cpu_Cpu_Interrupt (bean MC9S12XEP100_144)
**
**     Description :
**         The method services unhandled interrupt vectors.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
ISR(Cpu_Interrupt)
{
  asm(BGND);
}


/*
** ===================================================================
**     Method      :  Cpu_Delay100US (bean MC9S12XEP100_144)
**
**     Description :
**         This method realizes software delay. The length of delay
**         is at least 100 microsecond multiply input parameter
**         [us100]. As the delay implementation is not based on real
**         clock, the delay time may be increased by interrupt
**         service routines processed during the delay. The method
**         is independent on selected speed mode.
**     Parameters  :
**         NAME            - DESCRIPTION
**         us100           - Number of 100 us delay repetitions.
**                         - The value of zero results in maximal 
**                           delay of approx. 6.5 seconds.
**     Returns     : Nothing
** ===================================================================
*/
#pragma NO_ENTRY
#pragma NO_EXIT
#pragma MESSAGE DISABLE C5703
void Cpu_Delay100US(word us100)
{
  /* Total irremovable overhead: 13 cycles */
  /* ldd:  2 cycles overhead (load parameter into register) */
  /* jsr:  4 cycles overhead (call this function) */
  /* rts:  7 cycles overhead (return from this function) */

  asm {
    loop:
    /* 100 us delay block begin */

    /*
     * Delay
     *   - requested                  : 100 us @ 48MHz,
     *   - possible                   : 4800 c, 100000 ns
     *   - without removable overhead : 4797 c, 99937.5 ns
     */
    pshd                               /* (2 c: 41.67 ns) backup D */
    ldd #$063C                         /* (2 c: 41.67 ns) number of iterations */
    label0:
    dbne d, label0                     /* (3 c: 62.5 ns) repeat 1596x */
    puld                               /* (3 c: 62.5 ns) restore D */
    nop                                /* (1 c: 20.83 ns) wait for 1 c */
    nop                                /* (1 c: 20.83 ns) wait for 1 c */

    /* 100 us delay block end */
    dbne d, loop                       /* us100 parameter is passed via D register */
    rts                                /* return from subroutine */
  }
}

#pragma CODE_SEG DEFAULT

/*
** ===================================================================
**     Method      :  Cpu_DisableInt (bean MC9S12XEP100_144)
**
**     Description :
**         Disable maskable interrupts
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void Cpu_DisableInt(void)

**      This method is implemented as macro in the header module. **
*/

/*
** ===================================================================
**     Method      :  Cpu_EnableInt (bean MC9S12XEP100_144)
**
**     Description :
**         Enable maskable interrupts
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void Cpu_EnableInt(void)

**      This method is implemented as macro in the header module. **
*/

/*
** ===================================================================
**     Method      :  Cpu_SetStopMode (bean MC9S12XEP100_144)
**
**     Description :
**         Set low power mode - Stop mode.
**         For more information about the stop mode see
**         documentation of this CPU.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void Cpu_SetStopMode(void)

**      This method is implemented as macro in the header module. **
*/

/*
** ===================================================================
**     Method      :  Cpu_SetWaitMode (bean MC9S12XEP100_144)
**
**     Description :
**         Set low power mode - Wait mode.
**         For more information about the wait mode see
**         documentation of this CPU.
**         Release from Wait mode: Reset or interrupt
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void Cpu_SetWaitMode(void)

**      This method is implemented as macro in the header module. **
*/

#pragma OPTION ADD "-Onf"
/*
** ===================================================================
**     Method      :  PE_low_level_init (bean MC9S12XEP100_144)
**
**     Description :
**         Initializes beans and provides common register initialization. 
**         The method is called automatically as a part of the 
**         application initialization code.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
void PE_low_level_init(void)
{
  /* Int. priority initialization */
  /*                                        No. Address Pri XGATE Name            Description */
  setReg8(INT_CFADDR, 0xD0);            
  setReg8(INT_CFDATA3, 0x04);          /*  0x6B  0xFFD6   4   no   ivVsci0         used by PE */ 
  setReg8(INT_CFADDR, 0xE0);            
  setReg8(INT_CFDATA7, 0x04);          /*  0x77  0xFFEE   4   no   ivVectch0       used by PE */ 
  /* Initialization of Memory Protection unit */
  /* MPUSEL: SVSEN=0,??=0,??=0,??=0,??=0,SEL=1 */
  setReg8(MPUSEL, 0x01);               /* Select Descriptor num. 1 */ 
  /* MPUDESC2: LOW_ADDR10=0,LOW_ADDR9=0,LOW_ADDR8=0,LOW_ADDR7=0,LOW_ADDR6=0,LOW_ADDR5=0,LOW_ADDR4=0,LOW_ADDR3=0 */
  setReg8(MPUDESC2, 0x00);              
  /* MPUDESC1: LOW_ADDR18=0,LOW_ADDR17=0,LOW_ADDR16=0,LOW_ADDR15=0,LOW_ADDR14=0,LOW_ADDR13=0,LOW_ADDR12=0,LOW_ADDR11=0 */
  setReg8(MPUDESC1, 0x00);              
  /* MPUDESC0: MSTR0=0,MSTR1=0,MSTR2=0,MSTR3=0,LOW_ADDR22=0,LOW_ADDR21=0,LOW_ADDR20=0,LOW_ADDR19=0 */
  setReg8(MPUDESC0, 0x00);              
  /* MPUDESC5: HIGH_ADDR10=1,HIGH_ADDR9=1,HIGH_ADDR8=1,HIGH_ADDR7=1,HIGH_ADDR6=1,HIGH_ADDR5=1,HIGH_ADDR4=1,HIGH_ADDR3=1 */
  setReg8(MPUDESC5, 0xFF);              
  /* MPUDESC4: HIGH_ADDR18=1,HIGH_ADDR17=1,HIGH_ADDR16=1,HIGH_ADDR15=1,HIGH_ADDR14=1,HIGH_ADDR13=1,HIGH_ADDR12=1,HIGH_ADDR11=1 */
  setReg8(MPUDESC4, 0xFF);              
  /* MPUDESC3: WP=0,NEX=0,??=0,??=0,HIGH_ADDR22=1,HIGH_ADDR21=1,HIGH_ADDR20=1,HIGH_ADDR19=1 */
  setReg8(MPUDESC3, 0x0F);              
  /* MPUSEL: SVSEN=0,??=0,??=0,??=0,??=0,SEL=2 */
  setReg8(MPUSEL, 0x02);               /* Select Descriptor num. 2 */ 
  /* MPUDESC2: LOW_ADDR10=0,LOW_ADDR9=0,LOW_ADDR8=0,LOW_ADDR7=0,LOW_ADDR6=0,LOW_ADDR5=0,LOW_ADDR4=0,LOW_ADDR3=0 */
  setReg8(MPUDESC2, 0x00);              
  /* MPUDESC1: LOW_ADDR18=0,LOW_ADDR17=0,LOW_ADDR16=0,LOW_ADDR15=0,LOW_ADDR14=0,LOW_ADDR13=0,LOW_ADDR12=0,LOW_ADDR11=0 */
  setReg8(MPUDESC1, 0x00);              
  /* MPUDESC0: MSTR0=0,MSTR1=0,MSTR2=0,MSTR3=0,LOW_ADDR22=0,LOW_ADDR21=0,LOW_ADDR20=0,LOW_ADDR19=0 */
  setReg8(MPUDESC0, 0x00);              
  /* MPUDESC5: HIGH_ADDR10=1,HIGH_ADDR9=1,HIGH_ADDR8=1,HIGH_ADDR7=1,HIGH_ADDR6=1,HIGH_ADDR5=1,HIGH_ADDR4=1,HIGH_ADDR3=1 */
  setReg8(MPUDESC5, 0xFF);              
  /* MPUDESC4: HIGH_ADDR18=1,HIGH_ADDR17=1,HIGH_ADDR16=1,HIGH_ADDR15=1,HIGH_ADDR14=1,HIGH_ADDR13=1,HIGH_ADDR12=1,HIGH_ADDR11=1 */
  setReg8(MPUDESC4, 0xFF);              
  /* MPUDESC3: WP=0,NEX=0,??=0,??=0,HIGH_ADDR22=1,HIGH_ADDR21=1,HIGH_ADDR20=1,HIGH_ADDR19=1 */
  setReg8(MPUDESC3, 0x0F);              
  /* MPUSEL: SVSEN=0,??=0,??=0,??=0,??=0,SEL=3 */
  setReg8(MPUSEL, 0x03);               /* Select Descriptor num. 3 */ 
  /* MPUDESC2: LOW_ADDR10=0,LOW_ADDR9=0,LOW_ADDR8=0,LOW_ADDR7=0,LOW_ADDR6=0,LOW_ADDR5=0,LOW_ADDR4=0,LOW_ADDR3=0 */
  setReg8(MPUDESC2, 0x00);              
  /* MPUDESC1: LOW_ADDR18=0,LOW_ADDR17=0,LOW_ADDR16=0,LOW_ADDR15=0,LOW_ADDR14=0,LOW_ADDR13=0,LOW_ADDR12=0,LOW_ADDR11=0 */
  setReg8(MPUDESC1, 0x00);              
  /* MPUDESC0: MSTR0=0,MSTR1=0,MSTR2=0,MSTR3=0,LOW_ADDR22=0,LOW_ADDR21=0,LOW_ADDR20=0,LOW_ADDR19=0 */
  setReg8(MPUDESC0, 0x00);              
  /* MPUDESC5: HIGH_ADDR10=1,HIGH_ADDR9=1,HIGH_ADDR8=1,HIGH_ADDR7=1,HIGH_ADDR6=1,HIGH_ADDR5=1,HIGH_ADDR4=1,HIGH_ADDR3=1 */
  setReg8(MPUDESC5, 0xFF);              
  /* MPUDESC4: HIGH_ADDR18=1,HIGH_ADDR17=1,HIGH_ADDR16=1,HIGH_ADDR15=1,HIGH_ADDR14=1,HIGH_ADDR13=1,HIGH_ADDR12=1,HIGH_ADDR11=1 */
  setReg8(MPUDESC4, 0xFF);              
  /* MPUDESC3: WP=0,NEX=0,??=0,??=0,HIGH_ADDR22=1,HIGH_ADDR21=1,HIGH_ADDR20=1,HIGH_ADDR19=1 */
  setReg8(MPUDESC3, 0x0F);              
  /* MPUSEL: SVSEN=0,??=0,??=0,??=0,??=0,SEL=4 */
  setReg8(MPUSEL, 0x04);               /* Select Descriptor num. 4 */ 
  /* MPUDESC2: LOW_ADDR10=0,LOW_ADDR9=0,LOW_ADDR8=0,LOW_ADDR7=0,LOW_ADDR6=0,LOW_ADDR5=0,LOW_ADDR4=0,LOW_ADDR3=0 */
  setReg8(MPUDESC2, 0x00);              
  /* MPUDESC1: LOW_ADDR18=0,LOW_ADDR17=0,LOW_ADDR16=0,LOW_ADDR15=0,LOW_ADDR14=0,LOW_ADDR13=0,LOW_ADDR12=0,LOW_ADDR11=0 */
  setReg8(MPUDESC1, 0x00);              
  /* MPUDESC0: MSTR0=0,MSTR1=0,MSTR2=0,MSTR3=0,LOW_ADDR22=0,LOW_ADDR21=0,LOW_ADDR20=0,LOW_ADDR19=0 */
  setReg8(MPUDESC0, 0x00);              
  /* MPUDESC5: HIGH_ADDR10=1,HIGH_ADDR9=1,HIGH_ADDR8=1,HIGH_ADDR7=1,HIGH_ADDR6=1,HIGH_ADDR5=1,HIGH_ADDR4=1,HIGH_ADDR3=1 */
  setReg8(MPUDESC5, 0xFF);              
  /* MPUDESC4: HIGH_ADDR18=1,HIGH_ADDR17=1,HIGH_ADDR16=1,HIGH_ADDR15=1,HIGH_ADDR14=1,HIGH_ADDR13=1,HIGH_ADDR12=1,HIGH_ADDR11=1 */
  setReg8(MPUDESC4, 0xFF);              
  /* MPUDESC3: WP=0,NEX=0,??=0,??=0,HIGH_ADDR22=1,HIGH_ADDR21=1,HIGH_ADDR20=1,HIGH_ADDR19=1 */
  setReg8(MPUDESC3, 0x0F);              
  /* MPUSEL: SVSEN=0,??=0,??=0,??=0,??=0,SEL=5 */
  setReg8(MPUSEL, 0x05);               /* Select Descriptor num. 5 */ 
  /* MPUDESC2: LOW_ADDR10=0,LOW_ADDR9=0,LOW_ADDR8=0,LOW_ADDR7=0,LOW_ADDR6=0,LOW_ADDR5=0,LOW_ADDR4=0,LOW_ADDR3=0 */
  setReg8(MPUDESC2, 0x00);              
  /* MPUDESC1: LOW_ADDR18=0,LOW_ADDR17=0,LOW_ADDR16=0,LOW_ADDR15=0,LOW_ADDR14=0,LOW_ADDR13=0,LOW_ADDR12=0,LOW_ADDR11=0 */
  setReg8(MPUDESC1, 0x00);              
  /* MPUDESC0: MSTR0=0,MSTR1=0,MSTR2=0,MSTR3=0,LOW_ADDR22=0,LOW_ADDR21=0,LOW_ADDR20=0,LOW_ADDR19=0 */
  setReg8(MPUDESC0, 0x00);              
  /* MPUDESC5: HIGH_ADDR10=1,HIGH_ADDR9=1,HIGH_ADDR8=1,HIGH_ADDR7=1,HIGH_ADDR6=1,HIGH_ADDR5=1,HIGH_ADDR4=1,HIGH_ADDR3=1 */
  setReg8(MPUDESC5, 0xFF);              
  /* MPUDESC4: HIGH_ADDR18=1,HIGH_ADDR17=1,HIGH_ADDR16=1,HIGH_ADDR15=1,HIGH_ADDR14=1,HIGH_ADDR13=1,HIGH_ADDR12=1,HIGH_ADDR11=1 */
  setReg8(MPUDESC4, 0xFF);              
  /* MPUDESC3: WP=0,NEX=0,??=0,??=0,HIGH_ADDR22=1,HIGH_ADDR21=1,HIGH_ADDR20=1,HIGH_ADDR19=1 */
  setReg8(MPUDESC3, 0x0F);              
  /* MPUSEL: SVSEN=0,??=0,??=0,??=0,??=0,SEL=6 */
  setReg8(MPUSEL, 0x06);               /* Select Descriptor num. 6 */ 
  /* MPUDESC2: LOW_ADDR10=0,LOW_ADDR9=0,LOW_ADDR8=0,LOW_ADDR7=0,LOW_ADDR6=0,LOW_ADDR5=0,LOW_ADDR4=0,LOW_ADDR3=0 */
  setReg8(MPUDESC2, 0x00);              
  /* MPUDESC1: LOW_ADDR18=0,LOW_ADDR17=0,LOW_ADDR16=0,LOW_ADDR15=0,LOW_ADDR14=0,LOW_ADDR13=0,LOW_ADDR12=0,LOW_ADDR11=0 */
  setReg8(MPUDESC1, 0x00);              
  /* MPUDESC0: MSTR0=0,MSTR1=0,MSTR2=0,MSTR3=0,LOW_ADDR22=0,LOW_ADDR21=0,LOW_ADDR20=0,LOW_ADDR19=0 */
  setReg8(MPUDESC0, 0x00);              
  /* MPUDESC5: HIGH_ADDR10=1,HIGH_ADDR9=1,HIGH_ADDR8=1,HIGH_ADDR7=1,HIGH_ADDR6=1,HIGH_ADDR5=1,HIGH_ADDR4=1,HIGH_ADDR3=1 */
  setReg8(MPUDESC5, 0xFF);              
  /* MPUDESC4: HIGH_ADDR18=1,HIGH_ADDR17=1,HIGH_ADDR16=1,HIGH_ADDR15=1,HIGH_ADDR14=1,HIGH_ADDR13=1,HIGH_ADDR12=1,HIGH_ADDR11=1 */
  setReg8(MPUDESC4, 0xFF);              
  /* MPUDESC3: WP=0,NEX=0,??=0,??=0,HIGH_ADDR22=1,HIGH_ADDR21=1,HIGH_ADDR20=1,HIGH_ADDR19=1 */
  setReg8(MPUDESC3, 0x0F);              
  /* MPUSEL: SVSEN=0,??=0,??=0,??=0,??=0,SEL=7 */
  setReg8(MPUSEL, 0x07);               /* Select Descriptor num. 7 */ 
  /* MPUDESC2: LOW_ADDR10=0,LOW_ADDR9=0,LOW_ADDR8=0,LOW_ADDR7=0,LOW_ADDR6=0,LOW_ADDR5=0,LOW_ADDR4=0,LOW_ADDR3=0 */
  setReg8(MPUDESC2, 0x00);              
  /* MPUDESC1: LOW_ADDR18=0,LOW_ADDR17=0,LOW_ADDR16=0,LOW_ADDR15=0,LOW_ADDR14=0,LOW_ADDR13=0,LOW_ADDR12=0,LOW_ADDR11=0 */
  setReg8(MPUDESC1, 0x00);              
  /* MPUDESC0: MSTR0=0,MSTR1=0,MSTR2=0,MSTR3=0,LOW_ADDR22=0,LOW_ADDR21=0,LOW_ADDR20=0,LOW_ADDR19=0 */
  setReg8(MPUDESC0, 0x00);              
  /* MPUDESC5: HIGH_ADDR10=1,HIGH_ADDR9=1,HIGH_ADDR8=1,HIGH_ADDR7=1,HIGH_ADDR6=1,HIGH_ADDR5=1,HIGH_ADDR4=1,HIGH_ADDR3=1 */
  setReg8(MPUDESC5, 0xFF);              
  /* MPUDESC4: HIGH_ADDR18=1,HIGH_ADDR17=1,HIGH_ADDR16=1,HIGH_ADDR15=1,HIGH_ADDR14=1,HIGH_ADDR13=1,HIGH_ADDR12=1,HIGH_ADDR11=1 */
  setReg8(MPUDESC4, 0xFF);              
  /* MPUDESC3: WP=0,NEX=0,??=0,??=0,HIGH_ADDR22=1,HIGH_ADDR21=1,HIGH_ADDR20=1,HIGH_ADDR19=1 */
  setReg8(MPUDESC3, 0x0F);              
  /* MPUSEL: SVSEN=0,??=0,??=0,??=0,??=0,SEL=0 */
  setReg8(MPUSEL, 0x00);               /* Select Descriptor num. 0 */ 
  /* MPUDESC2: LOW_ADDR10=0,LOW_ADDR9=0,LOW_ADDR8=0,LOW_ADDR7=0,LOW_ADDR6=0,LOW_ADDR5=0,LOW_ADDR4=0,LOW_ADDR3=0 */
  setReg8(MPUDESC2, 0x00);              
  /* MPUDESC1: LOW_ADDR18=0,LOW_ADDR17=0,LOW_ADDR16=0,LOW_ADDR15=0,LOW_ADDR14=0,LOW_ADDR13=0,LOW_ADDR12=0,LOW_ADDR11=0 */
  setReg8(MPUDESC1, 0x00);              
  /* MPUDESC0: MSTR0=1,MSTR1=1,MSTR2=1,MSTR3=0,LOW_ADDR22=0,LOW_ADDR21=0,LOW_ADDR20=0,LOW_ADDR19=0 */
  setReg8(MPUDESC0, 0xE0);              
  /* MPUDESC5: HIGH_ADDR10=1,HIGH_ADDR9=1,HIGH_ADDR8=1,HIGH_ADDR7=1,HIGH_ADDR6=1,HIGH_ADDR5=1,HIGH_ADDR4=1,HIGH_ADDR3=1 */
  setReg8(MPUDESC5, 0xFF);              
  /* MPUDESC4: HIGH_ADDR18=1,HIGH_ADDR17=1,HIGH_ADDR16=1,HIGH_ADDR15=1,HIGH_ADDR14=1,HIGH_ADDR13=1,HIGH_ADDR12=1,HIGH_ADDR11=1 */
  setReg8(MPUDESC4, 0xFF);              
  /* MPUDESC3: WP=0,NEX=0,??=0,??=0,HIGH_ADDR22=1,HIGH_ADDR21=1,HIGH_ADDR20=1,HIGH_ADDR19=1 */
  setReg8(MPUDESC3, 0x0F);              
  /* Common initialization of the CPU registers */
  /* ECT_TSCR1: TEN=0,TSWAI=0,TSFRZ=1,TFFCA=0,PRNT=0,??=0,??=0,??=0 */
  setReg8(ECT_TSCR1, 0x20);             
  /* ECT_MCCTL: MODMC=1 */
  setReg8Bits(ECT_MCCTL, 0x40);         
  /* ECT_OCPD: OCPD0=1 */
  setReg8Bits(ECT_OCPD, 0x01);          
  /* ECT_PACTL: CLK1=0,CLK0=0 */
  clrReg8Bits(ECT_PACTL, 0x0C);         
  /* ECT_OC7M: OC7M0=0 */
  clrReg8Bits(ECT_OC7M, 0x01);          
  /* ECT_TIOS: IOS0=1 */
  setReg8Bits(ECT_TIOS, 0x01);          
  /* ECT_TCTL2: OM0=0,OL0=0 */
  clrReg8Bits(ECT_TCTL2, 0x03);         
  /* ECT_TTOV: TOV0=0 */
  clrReg8Bits(ECT_TTOV, 0x01);          
  /* ECT_TSCR2: TOI=0,TCRE=0,PR2=1,PR1=1,PR0=1 */
  clrSetReg8Bits(ECT_TSCR2, 0x88, 0x07); 
  /* ECT_TFLG1: C7F=1,C6F=1,C5F=1,C4F=1,C3F=1,C2F=1,C1F=1,C0F=1 */
  setReg8(ECT_TFLG1, 0xFF);             
  /* ECT_TIE: C0I=1 */
  setReg8Bits(ECT_TIE, 0x01);           
  /* PTS: PTS1=1 */
  setReg8Bits(PTS, 0x02);               
  /* DDRS: DDRS1=1,DDRS0=0 */
  clrSetReg8Bits(DDRS, 0x01, 0x02);     
  /* PORTA: PA7=0,PA6=0,PA5=0,PA4=0,PA3=0,PA2=0,PA1=0,PA0=0 */
  setReg8(PORTA, 0x00);                 
  /* PUCR: PUPAE=0 */
  clrReg8Bits(PUCR, 0x01);              
  /* DDRA: DDRA7=1,DDRA6=1,DDRA5=1,DDRA4=1,DDRA3=1,DDRA2=1,DDRA1=1,DDRA0=1 */
  setReg8(DDRA, 0xFF);                  
  /* CRGINT: LOCKIE=0,SCMIE=0 */
  clrReg8Bits(CRGINT, 0x12);            
  /* VREGCTRL: LVIE=0 */
  clrReg8Bits(VREGCTRL, 0x02);          
  /* COPCTL: RSBCK=0 */
  clrReg8Bits(COPCTL, 0x40);            
  /* DDR0AD1: DDR0AD17=1,DDR0AD16=1,DDR0AD15=1,DDR0AD14=1,DDR0AD13=1,DDR0AD12=1,DDR0AD11=1,DDR0AD10=1 */
  setReg8(DDR0AD1, 0xFF);               
  /* DDRF: DDRF7=1,DDRF6=1,DDRF5=1,DDRF4=1,DDRF3=1,DDRF2=1,DDRF1=1,DDRF0=1 */
  setReg8(DDRF, 0xFF);                  
  /* DDRJ: DDRJ3=1 */
  setReg8Bits(DDRJ, 0x08);              
  /* DDRL: DDRL7=1,DDRL6=1,DDRL5=1,DDRL4=1,DDRL3=1,DDRL2=1,DDRL1=1,DDRL0=1 */
  setReg8(DDRL, 0xFF);                  
  /* DDRR: DDRR7=1,DDRR6=1,DDRR5=1,DDRR4=1,DDRR3=1,DDRR2=1,DDRR1=1,DDRR0=1 */
  setReg8(DDRR, 0xFF);                  
  /* RDRIV: RDPK=0,RDPE=0,RDPD=0,RDPC=0,RDPB=0,RDPA=0 */
  clrReg8Bits(RDRIV, 0x9F);             
  /* RDR1AD1: RDR1AD17=0,RDR1AD16=0,RDR1AD15=0,RDR1AD14=0,RDR1AD13=0,RDR1AD12=0,RDR1AD11=0,RDR1AD10=0 */
  setReg8(RDR1AD1, 0x00);               
  /* RDRH: RDRH7=0,RDRH6=0,RDRH5=0,RDRH4=0,RDRH3=0,RDRH2=0,RDRH1=0,RDRH0=0 */
  setReg8(RDRH, 0x00);                  
  /* RDRJ: RDRJ7=0,RDRJ6=0,RDRJ5=0,RDRJ4=0,RDRJ2=0,RDRJ1=0,RDRJ0=0 */
  clrReg8Bits(RDRJ, 0xF7);              
  /* RDRM: RDRM7=0,RDRM6=0,RDRM5=0,RDRM4=0,RDRM3=0,RDRM2=0,RDRM1=0,RDRM0=0 */
  setReg8(RDRM, 0x00);                  
  /* RDRP: RDRP7=0,RDRP6=0,RDRP5=0,RDRP4=0,RDRP3=0,RDRP2=0,RDRP1=0,RDRP0=0 */
  setReg8(RDRP, 0x00);                  
  /* RDRS: RDRS7=0,RDRS6=0,RDRS5=0,RDRS4=0,RDRS3=0,RDRS2=0,RDRS1=0,RDRS0=0 */
  setReg8(RDRS, 0x00);                  
  /* RDRT: RDRT7=0,RDRT6=0,RDRT5=0,RDRT4=0,RDRT3=0,RDRT2=0,RDRT1=0,RDRT0=0 */
  setReg8(RDRT, 0x00);                  
  /* RDR0AD0: RDR0AD07=0,RDR0AD06=0,RDR0AD05=0,RDR0AD04=0,RDR0AD03=0,RDR0AD02=0,RDR0AD01=0,RDR0AD00=0 */
  setReg8(RDR0AD0, 0x00);               
  /* RDR1AD0: RDR1AD07=0,RDR1AD06=0,RDR1AD05=0,RDR1AD04=0,RDR1AD03=0,RDR1AD02=0,RDR1AD01=0,RDR1AD00=0 */
  setReg8(RDR1AD0, 0x00);               
  /* IRQCR: IRQEN=0 */
  clrReg8Bits(IRQCR, 0x40);             
  /* ### MC9S12XEP100_144 "Cpu" init code ... */
  /* ### TimerInt "TickTimer" init code ... */
  TickTimer_Init();
  /* ### Asynchro serial "COM0" init code ... */
  COM0_Init();
  /* ### ByteIO "Byte1" init code ... */
  Shadow_A = 0x00;                     /* Initialize port "Byte1" shadow variable */
 /* Common peripheral initialization - ENABLE */
  /* ECT_TSCR1: TEN=1 */
  setReg8Bits(ECT_TSCR1, 0x80);         
  asm {
    PSHA
    LDAA #0
    TFR A,CCRH
    PULA
  }
  __EI();                              /* Enable interrupts */
}

#pragma CODE_SEG __NEAR_SEG NON_BANKED

/*
** ===================================================================
**     Method      :  _EntryPoint (bean MC9S12XEP100_144)
**
**     Description :
**         Initializes the whole system like timing and so on. At the end 
**         of this function, the C startup is invoked to initialize stack,
**         memory areas and so on.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
extern void _Startup(void);            /* Forward declaration of external startup function declared in file Start12.c */
#pragma OPTION ADD "-Onf"              /* 'Create Sub-Functions with Common Code optimalization' must be disabled because stack is not yet initialized */

#pragma NO_FRAME
#pragma NO_EXIT
void _EntryPoint(void)
{
  /* ### MC9S12XEP100_144 "Cpu" init code ... */
  /*  PE initialization code after reset */
  /* ECLKCTL: NECLK=0,NCLKX2=1,DIV16=0,EDIV4=0,EDIV3=0,EDIV2=0,EDIV1=0,EDIV0=0 */
  setReg8(ECLKCTL, 0x40);               
  /* MMCCTL1: TGMRAMON=0,??=0,EEEIFRON=0,PGMIFRON=0,RAMHM=0,EROMON=0,ROMHM=0,ROMON=1 */
  setReg8(MMCCTL1, 0x01);               
  /* DIRECT: DP15=0,DP14=0,DP13=0,DP12=0,DP11=0,DP10=0,DP9=0,DP8=0 */
  setReg8(DIRECT, 0x00);                
  /* IVBR: IVB_ADDR=0xFF */
  setReg8(IVBR, 0xFF);                  
  /*  System clock initialization */
  /* CLKSEL: PLLSEL=0,PSTP=0,XCLKS=0,??=0,PLLWAI=0,??=0,RTIWAI=0,COPWAI=0 */
  setReg8(CLKSEL, 0x00);               /* Select clock source from XTAL and set bits in CLKSEL reg. */ 
  /* PLLCTL: CME=1,PLLON=0,FM1=0,FM0=0,FSTWKP=0,PRE=0,PCE=0,SCME=1 */
  setReg8(PLLCTL, 0x81);               /* Disable the PLL */ 
  /* SYNR: VCOFRQ1=1,VCOFRQ0=1,SYNDIV5=0,SYNDIV4=0,SYNDIV3=1,SYNDIV2=0,SYNDIV1=1,SYNDIV0=1 */
  setReg8(SYNR, 0xCB);                 /* Set the multiplier register */ 
  /* REFDV: REFFRQ1=0,REFFRQ0=1,REFDIV5=0,REFDIV4=0,REFDIV3=0,REFDIV2=0,REFDIV1=0,REFDIV0=0 */
  setReg8(REFDV, 0x40);                /* Set the divider register */ 
  /* POSTDIV: ??=0,??=0,??=0,POSTDIV4=0,POSTDIV3=0,POSTDIV2=0,POSTDIV1=0,POSTDIV0=0 */
  setReg8(POSTDIV, 0x00);              /* Set the post divider register */ 
  /* PLLCTL: CME=1,PLLON=1,FM1=0,FM0=0,FSTWKP=0,PRE=0,PCE=0,SCME=1 */
  setReg8(PLLCTL, 0xC1);                
  while(!CRGFLG_LOCK) {                /* Wait until the PLL is within the desired tolerance of the target frequency */
  }
  /* CLKSEL: PLLSEL=1 */
  setReg8Bits(CLKSEL, 0x80);           /* Select clock source from PLL */ 
  /* VREGHTCL: ??=0,??=0,VSEL=0,VAE=1,HTEN=0,HTDS=0,HTIE=0,HTIF=0 */
  setReg8(VREGHTCL, 0x10);              
  /*** End of PE initialization code after reset ***/
  __asm("jmp _Startup");               /* Jump to C startup code */
}

#pragma CODE_SEG DEFAULT
/* END Cpu. */

/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.98 [03.98]
**     for the Freescale HCS12X series of microcontrollers.
**
** ###################################################################
*/
