/*
	FreeRTOS.org V4.7.0 - Copyright (C) 2003-2007 Richard Barry.
	TriCore port - written by Adriaan Schmidt, Copyright (C) 2008 Siemens AG.

	This file is part of the FreeRTOS.org distribution.

	FreeRTOS.org is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
	The TriCore port is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	version 2 as published by the Free Software Foundation.

	FreeRTOS.org is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with FreeRTOS.org; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	A special exception to the GPL can be applied should you wish to distribute
	a combined work that includes FreeRTOS.org, without being obliged to provide
	the source code for any proprietary components.  See the licensing section
	of http://www.FreeRTOS.org for full details of how and when the exception
	can be applied.

	***************************************************************************
	See http://www.FreeRTOS.org for documentation, latest information, license
	and contact details.  Please ensure to read the configuration and relevant
	port sections of the online documentation.

	Also see http://www.SafeRTOS.com a version that has been certified for use
	in safety critical systems, plus commercial licensing, development and
	support options.
	***************************************************************************
*/

#ifndef __INCLUDE_TRICORE_IRQ_H__
#define __INCLUDE_TRICORE_IRQ_H__

#include "portmacro.h"

/** \file irq.c
 * This file implements a very basic way to receive and handle
 * interrupts (or Service Requests, as they are called on the Tricore).
 * Something about writing handlers:
 * - use a "void handler(void) __attribute__((interrupt_handler))" function
 */

/**
 * Init function for the basic IRQ system
 */
void vIrqInit();

/**
 * Enter a function into the vector table
 * \param ucNumber The vector number (and interrupt priority)
 * \param pxFunc The handler function
 * \param ucRunPrio The priority at which the handler will run
 */
void vIrqSetVector( unsigned portCHAR ucNumber, void (*pxFunc)(), unsigned portCHAR ucRunPrio );

#endif /* __INCLUDE_TRICORE_IRQ_H__ */

